<template>
  <div class="quiz-play-section">
    <!-- <main-header></main-header> -->
    <audio
      id="groundSound"
      loop
      autoplay="true"
      src="@/assets/audio/Game Show Timekeeper  SOUND EFFECT  Rhythm Quiz Show Background Music SOUNDS.mp3"
    ></audio>
    <div class="content-section position-relative">
      <img
        src="@/assets/img/game_overlay.png"
        class="bg position-absolute w-100 top-0 start-0"
      />
      <div class="container py-5">
        <div class="row">
          <div class="col col-12 col-lg-3 order-lg-last">
            <custom-rightbar></custom-rightbar>
          </div>
          <div class="col col-12 col-lg-9">
            <div
              class="play-wrap bg-white position-relative mt-5 mt-lg-0"
              style="overflow: hidden"
            >
              <div class="px-5 pt-5">
                <div
                  class="wrap-audio"
                  v-for="(item, i) in listQuestId.length"
                  :key="i"
                >
                  <audio
                    :id="'audio-' + item"
                    src="@/assets/audio/Answer 2.wav"
                  ></audio>
                </div>
                <one-question
                  type="quiz"
                  :quest-data="questData"
                  :list-quest-id="listQuestId"
                  @choose-answer="chooseAnswer"
                ></one-question>
              </div>
              <div class="game-timer px-5 pt-4 pb-3">
                <p class="fs-1 skiptranslate">{{ convertTime }}</p>
              </div>
            </div>
          </div>
          <div class="col col-12 d-lg-none mt-5">
            <user-info></user-info>
          </div>
        </div>
      </div>
    </div>

    <!-- <main-footer></main-footer> -->
  </div>
</template>

<script>
// import MainHeader from "../components/MainHeader.vue";
// import MainFooter from "../components/MainFooter.vue";
import CustomRightbar from "../components/play-quiz-survey/CustomRightbar.vue";
import UserInfo from "../components/play-quiz-survey/UserInfo.vue";
import OneQuestion from "../components/play-quiz-survey/OneQuestion.vue";
import { apiCustomerPost } from "../services/baseApi.js";
import sweetAlert from "../helper/sweetAlert.js";

export default {
  components: {
    // MainHeader,
    // MainFooter,
    CustomRightbar,
    UserInfo,
    OneQuestion,
  },
  data() {
    return {
      timeOut: 60,
      restASecond: 1000,
      secondIntervalId: null,
      listQuestId: [0],
      listAnswered: [],
      lastQuizzAnswer: null,
      questData: {},
      startDate: null,
      user: {},
      isPaused: true,
      onSubmit: false,
    };
  },
  computed: {
    convertTime() {
      let timeOut = this.timeOut;
      let minute = Math.floor(timeOut / 60);
      let second = timeOut % 60;

      minute = minute < 10 ? `0${minute}` : minute;
      second = second < 10 ? `0${second}` : second;
      return `${minute}:${second}`;
    },
  },
  watch: {
    timeOut(val) {
      if (val === 0) {
        // Clear all interval
        clearInterval(this.secondIntervalId);
        (function (w) {
          w = w || window;
          var i = w.setInterval(function () {}, 100000);
          while (i >= 0) {
            w.clearInterval(i--);
          }
        })(window);

        this.onSubmit = true;
        this.submitResult();
      }
    },
  },
  methods: {
    async getOneQuest(data) {
      try {
        if (!this.user.id) {
          sweetAlert.toastAlert(this, "error", "Can't get the question", 5000);
          return;
        }
        const body = {
          created_by: this.user.id,
          quiz: this.listQuestId,
        };

        // Call service question
        const res = await apiCustomerPost("start_quiz/one-quiz", body);

        if (!this.onSubmit && res && res.data && res.data.status) {
          this.startDate = res.data.data.start_date;

          if (!res.data.data.quiz) {
            sweetAlert.toastAlert(this, "info", "Can't get the question", 5000);
          } else {
            if (res.data.data.last_id === 0) {
              this.questData = res.data.data.quiz[0];
            } else {
              this.lastQuizzAnswer = res.data.data.quiz[0];
              if (
                this.lastQuizzAnswer &&
                data &&
                data.answered &&
                data.answered != this.lastQuizzAnswer.suggestanswer
              ) {
                sweetAlert.toastAlert(
                  this,
                  "info",
                  "You have an incorrect answer, you have out of today play, see you tommorow. Thank you so much"
                );
                this.submitResult();
              } else {
                this.questData = res.data.data.quiz[1];
              }
            }
            // this.questData = res.data.data.quiz;
            console.log(this.questData);
            // this.startGame();
          }
        }
      } catch (error) {
        console.log("error", error);
        localStorage.setItem("check_play", false);
        if (this.onSubmit) return;

        if (error.response && error.response.data) {
          error.response.data.code = error.response.status;

          this.$store.commit("setError", error.response.data);
          await sweetAlert.toastAlert(
            this,
            "info",
            error.response.data.message,
            false,
            true,
            "center",
            false
          );

          this.$router.push("/quiz-result").catch(() => {});
          return;
        }
        sweetAlert.toastAlert(this, "info", "There was an error");
      }
    },
    autoPlay() {
      let autoplay = document.getElementById("groundSound");
      autoplay.play();
    },
    startTimeOut() {
      this.secondIntervalId = setInterval(() => {
        if (this.isPaused == false) {
          if (this.restASecond === 0 || this.restASecond < 0) {
            this.restASecond = 1000;
            this.timeOut -= 1;
          }
          this.restASecond -= 10;
        }
      }, 10);
    },
    startGame() {
      this.isPaused = false;
    },
    pauseGame() {
      this.isPaused = true;
    },
    chooseAnswer(data) {
      // Save data answer
      this.listQuestId = [...this.listQuestId, data.id];
      this.listAnswered = [
        ...this.listAnswered,
        { quiz_id: data.id, answered: data.answered },
      ];

      localStorage.setItem("not-submited", JSON.stringify({
        customer_id: this.user.id,
        start_date: this.startDate,
        data: this.listAnswered,
      }));

      // Service new one question
      this.getOneQuest(data);
    },
    async submitResult() {
      try {
        let body = {
          customer_id: this.user.id,
          start_date: this.startDate,
          data: this.listAnswered,
        };
        if (!body.data.length) {
          body.data = [{ quiz_id: this.questData.id, answered: "" }];
        }

        let res = await apiCustomerPost("start_quiz/submit", body);
        if (res && res.data && res.data.status) {
          const { count_correct_answer, total_question } = res.data.data;
          this.$router
            .push(
              `/quiz-result/?correct-answer=${count_correct_answer}&total-quest=${total_question}
            &start-time=${this.startDate}`
            )
            .catch(() => {});
        }
      } catch (error) {
        console.log(error);
        sweetAlert.toastAlert(
          this,
          "error",
          "Please check you connection. Submit has failed."
        );
      }
    },
  },
  // created() {
  //   window.addEventListener('beforeunload', (e) => {
  //     e.preventDefault(); // If you prevent default behavior in Mozilla Firefox prompt will always be shown
  //     // Chrome requires returnValue to be set
  //     e.returnValue = 'aadsfasfd';
  //   })
  // },

  mounted() {
    const user = localStorage.getItem("user");
    localStorage.removeItem("check_play");

    if (user) {
      this.user = JSON.parse(user);
    }

    this.startTimeOut();
    this.autoPlay();
    this.startGame();
    this.getOneQuest();

    setTimeout(() => {
      document
        .getElementsByClassName("play-wrap")[0]
        .scrollIntoView({ block: "center" });
    }, 1000);
  },
  beforeDestroy() {
    clearInterval(this.secondIntervalId);
  },
};
</script>

<style scoped>
.content-section img {
  height: 100%;
  object-fit: cover;
  z-index: -1;
}
.play-wrap {
  border-radius: 32px;
}
</style>
